JUCE: MPESynthesiser Class Reference

JUCE

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
MPESynthesiser Class Reference
juce_audio_basics » mpe

Base class for an MPE-compatible musical device that can play sounds. More...

`#include <juce_MPESynthesiser.h>`

Inheritance diagram for MPESynthesiser:

## Public Member Functions
| MPESynthesiser ()
| Constructor. More...
| MPESynthesiser (MPEInstrument &instrumentToUse)
| Constructor to pass to the synthesiser a custom MPEInstrument object to handle the MPE note state, MIDI channel assignment etc. More...
| ~MPESynthesiser () override
| Destructor. More...
void | clearVoices ()
| Deletes all voices. More...
int | getNumVoices () const noexcept
| Returns the number of voices that have been added. More...
MPESynthesiserVoice * | getVoice (int index) const
| Returns one of the voices that have been added. More...
void | addVoice (MPESynthesiserVoice *newVoice)
| Adds a new voice to the synth. More...
void | removeVoice (int index)
| Deletes one of the voices. More...
void | reduceNumVoices (int newNumVoices)
| Reduces the number of voices to newNumVoices. More...
virtual void | turnOffAllVoices (bool allowTailOff)
| Release all MPE notes and turn off all voices. More...
void | setVoiceStealingEnabled (bool shouldSteal) noexcept
| If set to true, then the synth will try to take over an existing voice if it runs out and needs to play another note. More...
bool | isVoiceStealingEnabled () const noexcept
| Returns true if note-stealing is enabled. More...
void | setCurrentPlaybackSampleRate (double newRate) override
| Tells the synthesiser what the sample rate is for the audio it's being used to render. More...
void | handleMidiEvent (const MidiMessage &) override
| Handle incoming MIDI events. More...
virtual void | handleController (int, int, int)
| Callback for MIDI controller messages. More...
virtual void | handleProgramChange (int, int)
| Callback for MIDI program change messages. More...
Public Member Functions inherited from MPESynthesiserBase
| MPESynthesiserBase ()
| Constructor. More...
| MPESynthesiserBase (MPEInstrument &instrument)
| Constructor. More...
MPEZoneLayout | getZoneLayout () const noexcept
| Returns the synthesiser's internal MPE zone layout. More...
void | setZoneLayout (MPEZoneLayout newLayout)
| Re-sets the synthesiser's internal MPE zone layout to the one passed in. More...
virtual void | setCurrentPlaybackSampleRate (double sampleRate)
| Tells the synthesiser what the sample rate is for the audio it's being used to render. More...
double | getSampleRate () const noexcept
| Returns the current target sample rate at which rendering is being done. More...
template<typename floatType >
void | renderNextBlock (AudioBuffer< floatType > &outputAudio, const MidiBuffer &inputMidi, int startSample, int numSamples)
| Creates the next block of audio output. More...
virtual void | handleMidiEvent (const MidiMessage &)
| Handle incoming MIDI events (called from renderNextBlock). More...
void | setMinimumRenderingSubdivisionSize (int numSamples, bool shouldBeStrict=false) noexcept
| Sets a minimum limit on the size to which audio sub-blocks will be divided when rendering. More...
void | enableLegacyMode (int pitchbendRange=2, Range< int > channelRange=Range< int >(1, 17))
| Puts the synthesiser into legacy mode. More...
bool | isLegacyModeEnabled () const noexcept
| Returns true if the instrument is in legacy mode, false otherwise. More...
Range< int > | getLegacyModeChannelRange () const noexcept
| Returns the range of MIDI channels (1-16) to be used for notes when in legacy mode. More...
void | setLegacyModeChannelRange (Range< int > channelRange)
| Re-sets the range of MIDI channels (1-16) to be used for notes when in legacy mode. More...
int | getLegacyModePitchbendRange () const noexcept
| Returns the pitchbend range in semitones (0-96) to be used for notes when in legacy mode. More...
void | setLegacyModePitchbendRange (int pitchbendRange)
| Re-sets the pitchbend range in semitones (0-96) to be used for notes when in legacy mode. More...
void | setPressureTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the pressure dimension. More...
void | setPitchbendTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the pitchbend dimension. More...
void | setTimbreTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the timbre dimension. More...
Public Member Functions inherited from MPEInstrument::Listener
virtual | ~Listener ()=default
| Destructor. More...
virtual void | noteAdded (MPENote newNote)
| Implement this callback to be informed whenever a new expressive MIDI note is triggered. More...
virtual void | notePressureChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's pressure value changes. More...
virtual void | notePitchbendChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's pitchbend value changes. More...
virtual void | noteTimbreChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's timbre value changes. More...
virtual void | noteKeyStateChanged (MPENote changedNote)
| Implement this callback to be informed whether a currently playing MPE note's key state (whether the key is down and/or the note is sustained) has changed. More...
virtual void | noteReleased (MPENote finishedNote)
| Implement this callback to be informed whenever an MPE note is released (either by a note-off message, or by a sustain/sostenuto pedal release for a note that already received a note-off), and should therefore stop playing. More...
virtual void | zoneLayoutChanged ()
| Implement this callback to be informed whenever the MPE zone layout or legacy mode settings of this instrument have been changed. More...

## Protected Member Functions
void | noteAdded (MPENote newNote) override
| Attempts to start playing a new note. More...
void | noteReleased (MPENote finishedNote) override
| Stops playing a note. More...
void | notePressureChanged (MPENote changedNote) override
| Will find any voice that is currently playing changedNote, update its currently playing note, and call its notePressureChanged method. More...
void | notePitchbendChanged (MPENote changedNote) override
| Will find any voice that is currently playing changedNote, update its currently playing note, and call its notePitchbendChanged method. More...
void | noteTimbreChanged (MPENote changedNote) override
| Will find any voice that is currently playing changedNote, update its currently playing note, and call its noteTimbreChanged method. More...
void | noteKeyStateChanged (MPENote changedNote) override
| Will find any voice that is currently playing changedNote, update its currently playing note, and call its noteKeyStateChanged method. More...
void | renderNextSubBlock (AudioBuffer< float > &outputAudio, int startSample, int numSamples) override
| This will simply call renderNextBlock for each currently active voice and fill the buffer with the sum. More...
void | renderNextSubBlock (AudioBuffer< double > &outputAudio, int startSample, int numSamples) override
| This will simply call renderNextBlock for each currently active voice and fill the buffer with the sum. More...
virtual MPESynthesiserVoice * | findFreeVoice (MPENote noteToFindVoiceFor, bool stealIfNoneAvailable) const
| Searches through the voices to find one that's not currently playing, and which can play the given MPE note. More...
virtual MPESynthesiserVoice * | findVoiceToSteal (MPENote noteToStealVoiceFor=MPENote()) const
| Chooses a voice that is most suitable for being re-used to play a new note, or for being deleted by reduceNumVoices. More...
void | startVoice (MPESynthesiserVoice *voice, MPENote noteToStart)
| Starts a specified voice and tells it to play a particular MPENote. More...
void | stopVoice (MPESynthesiserVoice *voice, MPENote noteToStop, bool allowTailOff)
| Stops a given voice and tells it to stop playing a particular MPENote (which should be the same note it is actually playing). More...
virtual void | renderNextSubBlock (AudioBuffer< float > &outputAudio, int startSample, int numSamples)=0
| Implement this method to render your audio inside. More...
virtual void | renderNextSubBlock (AudioBuffer< double > &, int, int)
| Implement this method if you want to render 64-bit audio as well; otherwise leave blank. More...

## Protected Attributes
OwnedArray< MPESynthesiserVoice > | voices
CriticalSection | voicesLock
Protected Attributes inherited from MPESynthesiserBase
MPEInstrument & | instrument

## Additional Inherited Members
Public Types inherited from MPESynthesiserBase
using | TrackingMode = MPEInstrument::TrackingMode

## Detailed Description

Base class for an MPE-compatible musical device that can play sounds.

This class extends MPESynthesiserBase by adding the concept of voices, each of which can play a sound triggered by a MPENote that can be modulated by MPE dimensions like pressure, pitchbend, and timbre, while the note is sounding.

To create a synthesiser, you'll need to create a subclass of MPESynthesiserVoice which can play back one of these sounds at a time.

Then you can use the addVoice() methods to give the synthesiser a set of voices it can use to play notes. If you only give it one voice it will be monophonic - the more voices it has, the more polyphony it'll have available.

Then repeatedly call the renderNextBlock() method to produce the audio (inherited from MPESynthesiserBase). The voices will be started, stopped, and modulated automatically, based on the MPE/MIDI messages that the synthesiser receives.

Before rendering, be sure to call the setCurrentPlaybackSampleRate() to tell it what the target playback rate is. This value is passed on to the voices so that they can pitch their output correctly.

See also
  MPESynthesiserBase, MPESynthesiserVoice, MPENote, MPEInstrument

## Constructor & Destructor Documentation

## ◆ MPESynthesiser() [1/2]

MPESynthesiser::MPESynthesiser | ( |  | ) |

Constructor.

You'll need to add some voices before it'll make any sound.

See also
  addVoice

## ◆ MPESynthesiser() [2/2]

MPESynthesiser::MPESynthesiser | ( | MPEInstrument & | instrumentToUse | ) |

Constructor to pass to the synthesiser a custom MPEInstrument object to handle the MPE note state, MIDI channel assignment etc.

(in case you need custom logic for this that goes beyond MIDI and MPE).

See also
  MPESynthesiserBase, MPEInstrument

## ◆ ~MPESynthesiser()

MPESynthesiser::~MPESynthesiser | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ clearVoices()

void MPESynthesiser::clearVoices | ( |  | ) |

Deletes all voices.

## ◆ getNumVoices()

int MPESynthesiser::getNumVoices | ( |  | ) | const
| noexcept

Returns the number of voices that have been added.

## ◆ getVoice()

MPESynthesiserVoice * MPESynthesiser::getVoice | ( | int | index | ) | const

Returns one of the voices that have been added.

## ◆ addVoice()

void MPESynthesiser::addVoice | ( | MPESynthesiserVoice * | newVoice | ) |

Adds a new voice to the synth.

All the voices should be the same class of object and are treated equally.

The object passed in will be managed by the synthesiser, which will delete it later on when no longer needed. The caller should not retain a pointer to the voice.

## ◆ removeVoice()

void MPESynthesiser::removeVoice | ( | int | index | ) |

Deletes one of the voices.

## ◆ reduceNumVoices()

void MPESynthesiser::reduceNumVoices | ( | int | newNumVoices | ) |

Reduces the number of voices to newNumVoices.

This will repeatedly call findVoiceToSteal() and remove that voice, until the total number of voices equals newNumVoices. If newNumVoices is greater than or equal to the current number of voices, this method does nothing.

## ◆ turnOffAllVoices()

virtual void MPESynthesiser::turnOffAllVoices | ( | bool | allowTailOff | ) |
| virtual

Release all MPE notes and turn off all voices.

If allowTailOff is true, the voices will be allowed to fade out the notes gracefully (if they can do). If this is false, the notes will all be cut off immediately.

This method is meant to be called by the user, for example to implement a MIDI panic button in a synth.

## ◆ setVoiceStealingEnabled()

void MPESynthesiser::setVoiceStealingEnabled | ( | bool | shouldSteal | ) |
| noexcept

If set to true, then the synth will try to take over an existing voice if it runs out and needs to play another note.

The value of this boolean is passed into findFreeVoice(), so the result will depend on the implementation of this method.

## ◆ isVoiceStealingEnabled()

bool MPESynthesiser::isVoiceStealingEnabled | ( |  | ) | const
| noexcept

Returns true if note-stealing is enabled.

## ◆ setCurrentPlaybackSampleRate()

void MPESynthesiser::setCurrentPlaybackSampleRate | ( | double | newRate | ) |
| overridevirtual

Tells the synthesiser what the sample rate is for the audio it's being used to render.

This overrides the implementation in MPESynthesiserBase, to additionally propagate the new value to the voices so that they can use it to render the correct pitches.

Reimplemented from MPESynthesiserBase.

## ◆ handleMidiEvent()

void MPESynthesiser::handleMidiEvent | ( | const MidiMessage & |  | ) |
| overridevirtual

Handle incoming MIDI events.

This method will be called automatically according to the MIDI data passed into renderNextBlock(), but you can also call it yourself to manually inject MIDI events.

This implementation forwards program change messages and non-MPE-related controller messages to handleProgramChange and handleController, respectively, and then simply calls through to MPESynthesiserBase::handleMidiEvent to deal with MPE-related MIDI messages used for MPE notes, zones etc.

This method can be overridden further if you need to do custom MIDI handling on top of what is provided here.

Reimplemented from MPESynthesiserBase.

## ◆ handleController()

virtual void MPESynthesiser::handleController | ( | int | ,
|  | int | ,
|  | int |
| ) |  |
| virtual

Callback for MIDI controller messages.

The default implementation provided here does nothing; override this method if you need custom MIDI controller handling on top of MPE.

This method will be called automatically according to the midi data passed into renderNextBlock().

## ◆ handleProgramChange()

virtual void MPESynthesiser::handleProgramChange | ( | int | ,
|  | int |
| ) |  |
| virtual

Callback for MIDI program change messages.

The default implementation provided here does nothing; override this method if you need to handle those messages.

This method will be called automatically according to the midi data passed into renderNextBlock().

## ◆ noteAdded()

void MPESynthesiser::noteAdded | ( | MPENote | newNote | ) |
| overrideprotectedvirtual

Attempts to start playing a new note.

The default method here will find a free voice that is appropriate for playing the given MPENote, and use that voice to start playing the sound. If isNoteStealingEnabled returns true (set this by calling setNoteStealingEnabled), the synthesiser will use the voice stealing algorithm to find a free voice for the note (if no voices are free otherwise).

This method will be called automatically according to the midi data passed into renderNextBlock(). Do not call it yourself, otherwise the internal MPE note state will become inconsistent.

Reimplemented from MPEInstrument::Listener.

## ◆ noteReleased()

void MPESynthesiser::noteReleased | ( | MPENote | finishedNote | ) |
| overrideprotectedvirtual

Stops playing a note.

This will be called whenever an MPE note is released (either by a note-off message, or by a sustain/sostenuto pedal release for a note that already received a note-off), and should therefore stop playing.

This will find any voice that is currently playing finishedNote, turn its currently playing note off, and call its noteStopped callback.

This method will be called automatically according to the midi data passed into renderNextBlock(). Do not call it yourself, otherwise the internal MPE note state will become inconsistent.

Reimplemented from MPEInstrument::Listener.

## ◆ notePressureChanged()

void MPESynthesiser::notePressureChanged | ( | MPENote | changedNote | ) |
| overrideprotectedvirtual

Will find any voice that is currently playing changedNote, update its currently playing note, and call its notePressureChanged method.

This method will be called automatically according to the midi data passed into renderNextBlock(). Do not call it yourself.

Reimplemented from MPEInstrument::Listener.

## ◆ notePitchbendChanged()

void MPESynthesiser::notePitchbendChanged | ( | MPENote | changedNote | ) |
| overrideprotectedvirtual

Will find any voice that is currently playing changedNote, update its currently playing note, and call its notePitchbendChanged method.

This method will be called automatically according to the midi data passed into renderNextBlock(). Do not call it yourself.

Reimplemented from MPEInstrument::Listener.

## ◆ noteTimbreChanged()

void MPESynthesiser::noteTimbreChanged | ( | MPENote | changedNote | ) |
| overrideprotectedvirtual

Will find any voice that is currently playing changedNote, update its currently playing note, and call its noteTimbreChanged method.

This method will be called automatically according to the midi data passed into renderNextBlock(). Do not call it yourself.

Reimplemented from MPEInstrument::Listener.

## ◆ noteKeyStateChanged()

void MPESynthesiser::noteKeyStateChanged | ( | MPENote | changedNote | ) |
| overrideprotectedvirtual

Will find any voice that is currently playing changedNote, update its currently playing note, and call its noteKeyStateChanged method.

This method will be called automatically according to the midi data passed into renderNextBlock(). Do not call it yourself.

Reimplemented from MPEInstrument::Listener.

## ◆ renderNextSubBlock() [1/2]

void MPESynthesiser::renderNextSubBlock | ( | AudioBuffer< float > & | outputAudio,
|  | int | startSample,
|  | int | numSamples
| ) |  |
| overrideprotectedvirtual

This will simply call renderNextBlock for each currently active voice and fill the buffer with the sum.

Override this method if you need to do more work to render your audio.

Implements MPESynthesiserBase.

## ◆ renderNextSubBlock() [2/2]

void MPESynthesiser::renderNextSubBlock | ( | AudioBuffer< double > & | outputAudio,
|  | int | startSample,
|  | int | numSamples
| ) |  |
| overrideprotectedvirtual

This will simply call renderNextBlock for each currently active voice and fill the buffer with the sum.

(double-precision version) Override this method if you need to do more work to render your audio.

Reimplemented from MPESynthesiserBase.

## ◆ findFreeVoice()

virtual MPESynthesiserVoice * MPESynthesiser::findFreeVoice | ( | MPENote | noteToFindVoiceFor,
|  | bool | stealIfNoneAvailable
| ) |  | const
| protectedvirtual

Searches through the voices to find one that's not currently playing, and which can play the given MPE note.

If all voices are active and stealIfNoneAvailable is false, this returns a nullptr. If all voices are active and stealIfNoneAvailable is true, this will call findVoiceToSteal() to find a voice.

If you need to find a free voice for something else than playing a note (e.g. for deleting it), you can pass an invalid (default-constructed) MPENote.

## ◆ findVoiceToSteal()

virtual MPESynthesiserVoice * MPESynthesiser::findVoiceToSteal | ( | MPENote | noteToStealVoiceFor = `MPENote()` | ) | const
| protectedvirtual

Chooses a voice that is most suitable for being re-used to play a new note, or for being deleted by reduceNumVoices.

The default method will attempt to find the oldest voice that isn't the bottom or top note being played. If that's not suitable for your synth, you can override this method and do something more cunning instead.

If you pass a valid MPENote for the optional argument, then the note number of that note will be taken into account for finding the ideal voice to steal. If you pass an invalid (default-constructed) MPENote instead, this part of the algorithm will be ignored.

## ◆ startVoice()

void MPESynthesiser::startVoice | ( | MPESynthesiserVoice * | voice,
|  | MPENote | noteToStart
| ) |  |
| protected

Starts a specified voice and tells it to play a particular MPENote.

You should never need to call this, it's called internally by MPESynthesiserBase::instrument via the noteStarted callback, but is protected in case it's useful for some custom subclasses.

## ◆ stopVoice()

void MPESynthesiser::stopVoice | ( | MPESynthesiserVoice * | voice,
|  | MPENote | noteToStop,
|  | bool | allowTailOff
| ) |  |
| protected

Stops a given voice and tells it to stop playing a particular MPENote (which should be the same note it is actually playing).

You should never need to call this, it's called internally by MPESynthesiserBase::instrument via the noteReleased callback, but is protected in case it's useful for some custom subclasses.

## Member Data Documentation

## ◆ voices

OwnedArray<MPESynthesiserVoice> MPESynthesiser::voices
| protected

## ◆ voicesLock

CriticalSection MPESynthesiser::voicesLock
| protected

The documentation for this class was generated from the following file:

- juce_MPESynthesiser.h